package cls.data;

import okay.database.Database;
import okay.database.DatabaseConnection;

/**
 * Represents data layer.
 *
 * @author Robert Vokáč e-mail: robertvokac1@gmail.com
 */
public class Data {

    private static final String DATABASENAME = "data";

    private final DatabaseConnection databaseConnection;

    private final boolean launchedForFirstTime;

    /**
     * Constructor
     */
    public Data() {
        launchedForFirstTime = !Database.existsDatabase(DATABASENAME);
        if (launchedForFirstTime) {
            Database.createDatabase(DATABASENAME);
        }
        this.databaseConnection = Database.createDatabaseConnection(DATABASENAME);
    }

    /**
     *
     * @return
     */
    public DatabaseConnection getDatabaseConnection() {
        return this.databaseConnection;
    }

    /**
     *
     * @return
     */
    public boolean isLaunchedForFirstTime() {
        return this.launchedForFirstTime;
    }
}
