package cls.domain;

import cls.logic.composition.ExplodingShapeType;
import static cls.domain.Table.databaseConnection;
import okay.database.ResultOfSqlQuery;
import okay.json.JsonObject;

/**
 *
 * @author Robert Vokáč e-mail: robertvokac1@gmail.com
 */
public class ExplodingShapeTypeTable extends Table {

    /**
     * Constructor
     *
     * Not meant to be instantiated.
     */
    private ExplodingShapeTypeTable() {
        //Not meant to be instantiated.
    }

    static ExplodingShapeType getExplodingShapeType(int explodingShapeTypeId) {
        ExplodingShapeType explodingShapeType;
        JsonObject boardCompositionJsonObject = databaseConnection.getRow("exploding_shape_type", explodingShapeTypeId);

        explodingShapeType = ExplodingShapeType.valueOf(boardCompositionJsonObject.getString("name"));

        return explodingShapeType;
    }

    /**
     *
     * @param name
     * @return
     */
    public static int saveExplodingShapeType(String name) {
        StringBuilder insertCommandStringBuilder = new StringBuilder("INSERT INTO exploding_shape_type VALUES (null,'");
        insertCommandStringBuilder.append(name).append("')");
        return databaseConnection.execute(insertCommandStringBuilder.toString());
    }

    /**
     *
     * @param name
     * @return id of the row with the given name
     */
    public static int getId(String name) {
        ResultOfSqlQuery resultOfSqlQuery = databaseConnection.executeAndReturn("SELECT id FROM exploding_shape_type where name='" + name + "'");
        resultOfSqlQuery.moveToTheNextRow();
        return resultOfSqlQuery.getInt("id");
    }

}
