package cls.domain;

import cls.logic.composition.GameComposition;
import cls.logic.composition.Shape;
import okay.database.ResultOfSqlQuery;

/**
 *
 * @author Robert Vokáč e-mail: robertvokac1@gmail.com
 */
public class GameTable extends Table {

    /**
     * Constructor
     *
     * Not meant to be instantiated.
     */
    private GameTable() {
        //Not meant to be instantiated.
    }

    /**
     *
     * @param sessionId
     * @param playerId
     * @param gameCompositionId
     * @param pseudoRandomNumberGeneratorId
     * @return
     */
    public static int saveGameTable(int sessionId, int playerId, int gameCompositionId, int pseudoRandomNumberGeneratorId) {
        String command
                = "INSERT INTO game VALUES (null,"
                + sessionId + ","
                + playerId + ","
                + gameCompositionId + ",-999999,"
                + pseudoRandomNumberGeneratorId
                + ")";
        return databaseConnection.execute(command);
    }

    /**
     *
     * @param playerId
     * @return
     */
    public static int getLastPlayedGameCompositionId(int playerId) {
        String command
                = "SELECT game_composition_id FROM game WHERE id = (select max(id) from game where player_id = " + playerId + ");";
        ResultOfSqlQuery resultOfSqlQuery = databaseConnection.executeAndReturn(command);

        if (resultOfSqlQuery.isEmpty()) {
            GameComposition defaultGameComposition = new GameComposition();
            defaultGameComposition.getBoardComposition().setShape(new Shape(9, 9));
            return GameCompositionTable.getId(defaultGameComposition);
        }
        resultOfSqlQuery.moveToTheNextRow();
        return resultOfSqlQuery.getInt("game_composition_id");
    }

    /**
     *
     * @param gameId
     * @param score
     */
    public static void setScore(int gameId, int score) {
        databaseConnection.updateValue("game", gameId, "result_score", score);
    }
}
