package cls.domain;

import cls.logic.composition.OtherComposition;
import static cls.domain.Table.databaseConnection;
import okay.database.ResultOfSqlQuery;
import okay.json.JsonObject;

/**
 *
 * @author Robert Vokáč e-mail: robertvokac1@gmail.com
 */
public class OtherTable extends Table {

    public static final String TABLENAME = "other";
    public static final String ALLOWED_STEP_BACK = "allowed_step_back";
    public static final String FREEMODE = "free_mode";
    public static final String TRAINER = "trainer";

    /**
     * Constructor
     *
     * Not meant to be instantiated.
     */
    private OtherTable() {
        //Not meant to be instantiated.
    }

    static OtherComposition getOtherComposition(int otherCompositionId) {
        OtherComposition otherComposition;
        JsonObject otherCompositionJsonObject = databaseConnection.getRow(TABLENAME, otherCompositionId);

        otherComposition = new OtherComposition(
                Integer.parseInt(otherCompositionJsonObject.getString(ALLOWED_STEP_BACK)) == 1,
                Integer.parseInt(otherCompositionJsonObject.getString(FREEMODE)) == 1,
                Integer.parseInt(otherCompositionJsonObject.getString(TRAINER)) == 1
        );
        return otherComposition;
    }

    /**
     *
     * @param allowedStepBack
     * @param freeMode
     * @param trainer
     * @return
     */
    public static int saveOther(boolean allowedStepBack, boolean freeMode, boolean trainer) {
        StringBuilder insertCommandStringBuilder = new StringBuilder("INSERT INTO other VALUES (null,");
        insertCommandStringBuilder.append(booleanToInt(allowedStepBack)).append(",");
        insertCommandStringBuilder.append(booleanToInt(freeMode)).append(",");
        insertCommandStringBuilder.append(booleanToInt(trainer)).append(")");
        return databaseConnection.execute(insertCommandStringBuilder.toString());
    }

    /**
     *
     * @param otherComposition
     * @return
     */
    public static int getId(OtherComposition otherComposition) {
        boolean allowedStepBack = otherComposition.getAllowedStepBack();
        boolean freeMode = otherComposition.getFreeMode();
        boolean trainer = otherComposition.getTrainer();

        String sqlQueryString
                = "SELECT * FROM other WHERE "
                + "allowed_step_back = "
                + (allowedStepBack ? 1 : 0)
                + " AND free_mode= "
                + (freeMode ? 1 : 0)
                + " AND trainer= "
                + (trainer ? 1 : 0);

        ResultOfSqlQuery resultOfSqlQuery = databaseConnection.executeAndReturn(sqlQueryString);
        if (resultOfSqlQuery.isEmpty()) {
            return saveOther(allowedStepBack, freeMode, trainer);
        } else {
            resultOfSqlQuery.moveToTheNextRow();
            return resultOfSqlQuery.getInt("id");
        }
    }
}
