package cls.domain;

import okay.datetime.UniversalDateTime;
import okay.json.JsonObject;
import okay.pseudorandom.PseudoRandomGenerator;

/**
 *
 * @author Robert Vokáč e-mail: robertvokac1@gmail.com
 */
public class PseudoRandomGeneratorTable extends Table {

    /**
     * Constructor
     *
     * Not meant to be instantiated.
     */
    private PseudoRandomGeneratorTable() {
        //Not meant to be instantiated.
    }

    /**
     *
     * @param magicNumber
     * @param magicUniversalDateTimeId
     * @return
     */
    public static int savePseudoRandomGenerator(int magicNumber, int magicUniversalDateTimeId) {
        StringBuilder insertCommandStringBuilder = new StringBuilder("INSERT INTO pseudo_random_generator VALUES (null,");
        insertCommandStringBuilder.append(magicNumber).append(",");
        insertCommandStringBuilder.append(magicUniversalDateTimeId).append(")");

        return databaseConnection.execute(insertCommandStringBuilder.toString());
    }

    /**
     *
     * @param id
     * @return instance of PseudoRandomGenerator
     */
    public static PseudoRandomGenerator getPseudoRandomGenerator(int id) {
        JsonObject jsonObject = databaseConnection.getRow("pseudo_random_generator", id);
        long magicNumber = Long.parseLong(jsonObject.getString("magic_number"));
        int universalDateTimeId = Integer.parseInt(jsonObject.getString("magic_universal_date_time_id"));
        UniversalDateTime universalDateTime = UniversalDateTimeTable.getUniversalDateTime(universalDateTimeId);
        return new PseudoRandomGenerator(magicNumber, universalDateTime);
    }
}
