package cls.domain;

import cls.logic.composition.Shape;
import static cls.domain.Table.databaseConnection;
import okay.database.ResultOfSqlQuery;
import okay.json.JsonObject;

/**
 *
 * @author Robert Vokáč e-mail: robertvokac1@gmail.com
 */
public class ShapeTable extends Table {

    /**
     * Constructor
     *
     * Not meant to be instantiated.
     */
    private ShapeTable() {
        //Not meant to be instantiated.
    }

    static Shape getShape(int shapeId) {
        Shape shape;
        JsonObject shapeJsonObject = databaseConnection.getRow("shape", shapeId);

        shape = new Shape(
                Integer.parseInt(shapeJsonObject.getString("height")),
                Integer.parseInt(shapeJsonObject.getString("width"))
        );
        return shape;
    }

    /**
     *
     * @param height
     * @param width
     * @param description
     * @return
     */
    public static int saveShape(int height, int width, String description) {
        StringBuilder insertCommandStringBuilder = new StringBuilder("INSERT INTO shape VALUES (null,");
        insertCommandStringBuilder.append(height).append(",");
        insertCommandStringBuilder.append(width).append(",'");
        insertCommandStringBuilder.append(description).append("')");
        return databaseConnection.execute(insertCommandStringBuilder.toString());
    }

    /**
     *
     * @return
     */
    public static int saveEmptyShape() {
        return databaseConnection.execute("INSERT INTO shape VALUES (0,1,1,'')");
    }

    /**
     *
     * @param shape
     * @return
     */
    public static int getId(Shape shape) {
        int height = shape.getHeight();
        int width = shape.getWidth();

        String sqlQueryString
                = "SELECT * FROM shape WHERE height = "
                + height
                + " AND width = "
                + width;

        ResultOfSqlQuery resultOfSqlQuery = databaseConnection.executeAndReturn(sqlQueryString);
        if (resultOfSqlQuery.isEmpty()) {
            return saveShape(height, width, "height " + height + " * " + "width " + width);
        } else {
            resultOfSqlQuery.moveToTheNextRow();
            return resultOfSqlQuery.getInt("id");
        }
    }
}
