package cls.domain;

import static cls.domain.Table.databaseConnection;
import okay.datetime.UniversalDateTime;
import okay.json.JsonObject;

/**
 *
 * @author Robert Vokáč e-mail: robertvokac1@gmail.com
 */
public class UniversalDateTimeTable extends Table {

    /**
     * Constructor
     *
     * Not meant to be instantiated.
     */
    private UniversalDateTimeTable() {
        //Not meant to be instantiated.
    }

    /**
     *
     * @return id of new session
     */
    public static int saveCurrentUniversalDateTime() {
        UniversalDateTime universalDateTime = UniversalDateTime.getCurrentUniversalDateTime();
        return saveUniversalDateTime(universalDateTime);
    }

    /**
     *
     * @param universalDateTime
     * @return id of new session
     */
    public static int saveUniversalDateTime(UniversalDateTime universalDateTime) {

        StringBuilder insertCommandStringBuilder = new StringBuilder("INSERT INTO universal_date_time VALUES(null,");
        insertCommandStringBuilder.append(universalDateTime.getYear());
        insertCommandStringBuilder.append(',');
        insertCommandStringBuilder.append(universalDateTime.getMonth());
        insertCommandStringBuilder.append(',');
        insertCommandStringBuilder.append(universalDateTime.getDay());
        insertCommandStringBuilder.append(',');
        insertCommandStringBuilder.append(universalDateTime.getHour());
        insertCommandStringBuilder.append(',');
        insertCommandStringBuilder.append(universalDateTime.getMinute());
        insertCommandStringBuilder.append(',');
        insertCommandStringBuilder.append(universalDateTime.getSecond());
        insertCommandStringBuilder.append(',');
        insertCommandStringBuilder.append(universalDateTime.getMillisecond());
        insertCommandStringBuilder.append(')');
        return databaseConnection.execute(insertCommandStringBuilder.toString());
    }

    /**
     *
     * @param universalDateTimeId
     * @return
     */
    public static JsonObject loadUniversalDateTime(int universalDateTimeId) {
        return databaseConnection.getRow("universal_date_time", universalDateTimeId);
    }

    /**
     *
     * @param id
     * @return
     */
    public static UniversalDateTime getUniversalDateTime(int id) {
        JsonObject jsonObject = loadUniversalDateTime(id);
        return new UniversalDateTime(
                Integer.parseInt(jsonObject.getString("year")),
                Integer.parseInt(jsonObject.getString("month")),
                Integer.parseInt(jsonObject.getString("day")),
                Integer.parseInt(jsonObject.getString("hour")),
                Integer.parseInt(jsonObject.getString("minute")),
                Integer.parseInt(jsonObject.getString("second")),
                Integer.parseInt(jsonObject.getString("millisecond"))
        );
    }
}
