package cls.logic;

import cls.domain.PlayerTable;
import okay.simplicity.EnumColour;

/**
 *
 * @author Robert Vokáč e-mail: robertvokac1@gmail.com
 */
public class ApplicationLookForPlayer implements ApplicationLook {

    private final int playerId;

    /**
     * Constructor
     *
     * @param playerId
     */
    public ApplicationLookForPlayer(int playerId) {
        this.playerId = playerId;
    }

    @Override
    public int getLanguageId() {
        return PlayerTable.getLanguageId(playerId);
    }

    @Override
    public void setLanguageId(int id) {
        PlayerTable.setLanguageId(playerId, id);
    }

    @Override
    public EnumColour getColourSkin() {
        return EnumColour.convertNumberToEnumColour(PlayerTable.getSkin(playerId));
    }

    @Override
    public void setColourSkin(EnumColour colourSkin) {
        PlayerTable.setSkin(playerId, colourSkin.getNumber());
    }

    @Override
    public int getZoom() {
        return PlayerTable.getZoom(playerId);
    }

    @Override
    public void setZoom(int zoom) {
        PlayerTable.setZoom(playerId, zoom);
    }

}
