package cls.logic;

import cls.domain.GameCompositionTable;
import cls.logic.composition.GameComposition;
import cls.logic.game.Game;
import okay.json.JsonObject;

/**
 *
 * @author Robert Vokáč e-mail: robertvokac1@gmail.com
 */
public class GameManager {

    private final Logic logic;

    private Game game = null;

    private GameComposition currentGameComposition = new GameComposition();
    private int currentGameCompositionId;

    GameManager(Logic logic) {
        this.logic = logic;
    }

    public GameComposition getGameComposition() {
        return this.currentGameComposition;
    }

    public void setGameComposition(GameComposition gameComposition) {
        this.currentGameComposition = gameComposition;
        currentGameCompositionId = GameCompositionTable.getId(this.currentGameComposition);
    }

    public void playNewGame() {
        if (this.game != null) {
            game.end(true);
        }
        Game game = new Game(this.currentGameComposition);
        this.game = game;
    }

    public Game getGame() {
        return this.game;
    }

    /**
     *
     * @param jsonObject
     */
    public void setGameCompositionByJsonObject(JsonObject jsonObject) {
        this.currentGameComposition = new GameComposition(jsonObject);
        currentGameCompositionId = GameCompositionTable.getId(this.currentGameComposition);
    }

    /**
     *
     * @return
     */
    public JsonObject getGameCompositionAsJsonObject() {
        return this.currentGameComposition.toJsonObject();
    }

    /**
     *
     */
    public void setGameCompositionDefault() {
        this.currentGameComposition.setDefaultValues();
    }

    /**
     *
     */
    public void setGameCompositionRandom() {
        this.currentGameComposition.setRandomValues();
    }

    public int getGameCompositionId() {
        return this.currentGameCompositionId;
    }

    public void activateField(int row, int column) {
        this.game.activateField(row, column);
    }
}
