package cls.logic;

import cls.domain.ApplicationSessionTable;
import cls.domain.PlayerSessionTable;
import cls.domain.SessionTable;
import cls.domain.UniversalDateTimeTable;

/**
 *
 * @author Robert Vokáč e-mail: robertvokac1@gmail.com
 */
public class Logger {

    private int applicationSessionSSessionId;
    private int playerSessionSSessionId;

    /**
     * Logs application start.
     */
    public void logApplicationStart() {
        int currentUniversalDateTimeId = UniversalDateTimeTable.saveCurrentUniversalDateTime();
        applicationSessionSSessionId = SessionTable.saveSession(currentUniversalDateTimeId);
        ApplicationSessionTable.saveApplicationSession(applicationSessionSSessionId);
    }

    /**
     * Logs application exit.
     */
    public void logApplicationEnd() {
        int currentUniversalDateTimeId = UniversalDateTimeTable.saveCurrentUniversalDateTime();
        SessionTable.setEndUniversalDateTimeId(applicationSessionSSessionId, currentUniversalDateTimeId);
    }

    /**
     * Logs player's login.
     *
     * @param playerId
     */
    public void logPlayerLoggedIn(int playerId) {
        int currentUniversalDateTimeId = UniversalDateTimeTable.saveCurrentUniversalDateTime();
        playerSessionSSessionId = SessionTable.saveSession(currentUniversalDateTimeId);
        PlayerSessionTable.savePlayerSession(playerSessionSSessionId, playerId);
    }

    /**
     * Logs player's logout.
     */
    public void logPlayerLoggedOut() {
        int currentUniversalDateTimeId = UniversalDateTimeTable.saveCurrentUniversalDateTime();
        SessionTable.setEndUniversalDateTimeId(playerSessionSSessionId, currentUniversalDateTimeId);
    }
}
