package cls.logic;

import cls.domain.LanguageTable;
import cls.domain.TextConstantTable;
import okay.database.ResultOfSqlQuery;
import okay.json.JsonObject;

/**
 *
 * @author Robert Vokáč robertvokac1@gmail.comt Vokáč robertvokac1@gmail.com
 */
public class TextSource {

    private final Logic logic;
    private int languageId;

    /**
     *
     * @param logic
     */
    public TextSource(Logic logic) {
        this.logic = logic;
        this.languageId = logic.getApplication().getApplicationLook().getLanguageId();
    }

    public void setLanguageId(int languageId) {
        this.languageId = languageId;
    }

    /**
     *
     * @param type
     * @param languageID
     * @return
     */
    public String getTextConstant(int type) {
        return TextConstantTable.getTextConstant(type, languageId);
    }

    /**
     *
     * @return
     */
    public ResultOfSqlQuery getLanguages() {
        return LanguageTable.getLanguages();
    }

    /**
     *
     * @param language
     * @return
     */
    public int convertLanguageNameToLanguageId(String language) {
        return LanguageTable.getIdFromLanguageName(language);
    }

    /**
     *
     * @param languageID
     * @return
     */
    public String convertLanguageIdToLanguageName(int languageId) {
        return LanguageTable.getLanguageNameFromLanguageId(languageId);
    }

    /**
     *
     * @return
     */
    public JsonObject createNewLanguage() {
        throw new UnsupportedOperationException();
    }

    /**
     *
     * @return
     */
    public JsonObject editLanguage() {
        throw new UnsupportedOperationException();
    }

    /**
     *
     * @return
     */
    public JsonObject updateLanguage() {
        throw new UnsupportedOperationException();
    }
}
