package cls.logic.composition;

import cls.ColorLinesSequelRuntimeException;

/**
 *
 * @author Robert Vokáč robertvokac1@gmail.comt Vokáč robertvokac1@gmail.com
 */
public enum ExplodingShapeType {

    /**
     * line
     */
    LINE,
    /**
     * block
     */
    BLOCK,
    /**
     * ring
     */
    RING,
    /**
     * square
     */
    SQUARE,
    /**
     * custom
     */
    CUSTOM;

    /**
     *
     * @param id
     * @return
     */
    public static ExplodingShapeType convertFromInt(int id) {
        ExplodingShapeType explodingShape;
        switch (id) {
            case 1:
                explodingShape = ExplodingShapeType.LINE;
                break;
            case 2:
                explodingShape = ExplodingShapeType.BLOCK;
                break;
            case 3:
                explodingShape = ExplodingShapeType.RING;
                break;
            case 4:
                explodingShape = ExplodingShapeType.SQUARE;
                break;
            case 5:
                explodingShape = ExplodingShapeType.CUSTOM;
                break;
            default:
                throw new ColorLinesSequelRuntimeException("There is no such exploding shape type. It can be only 1,2,3,4 or 5.");
        }
        return explodingShape;
    }
}
