package cls.logic.composition;

import okay.json.JsonObject;

/**
 * Represents hole of a shape.
 *
 * @author Robert Vokáč e-mail: robertvokac1@gmail.com
 */
public class Hole {

    private final int column;
    private final int row;

    /**
     *
     * @param holeJsonObject
     */
    public Hole(JsonObject holeJsonObject) {
        this.column = holeJsonObject.getInt("column");
        this.row = holeJsonObject.getInt("row");
    }

    /**
     *
     * @param column
     * @param row
     */
    public Hole(int column, int row) {
        this.column = column;
        this.row = row;
    }

    /**
     *
     * @return
     */
    public int getColumn() {
        return column;
    }

    /**
     *
     * @return
     */
    public int getRow() {
        return row;
    }

    /**
     *
     * @return
     */
    public JsonObject toJsonObject() {
        JsonObject holeJsonObject = new JsonObject();
        holeJsonObject.addInt("column", column);
        holeJsonObject.addInt("row", row);

        return null;
    }
}
