package cls.logic.composition;

import cls.logic.composition.lockableobject.LockableObject;
import java.util.ArrayList;
import java.util.List;
import okay.json.JsonObject;

/**
 *
 * @author Robert Vokáč robertvokac1@gmail.comt Vokáč robertvokac1@gmail.com
 */
public class OtherComposition extends LockableObject {

    private boolean allowedStepBack;
    private boolean freeMode;
    private boolean trainer;

    /**
     *
     * @param otherJsonObject
     */
    public OtherComposition(JsonObject otherJsonObject) {
        this.updateByJsonObject(otherJsonObject);
    }

    /**
     * Constructor
     */
    public OtherComposition() {

        this.setDefaultValues();
    }

    /**
     *
     * @param allowedStepBack
     * @param freeMode
     * @param trainer
     */
    public OtherComposition(boolean allowedStepBack, boolean freeMode, boolean trainer) {

        this.allowedStepBack = allowedStepBack;
        this.freeMode = freeMode;
        this.trainer = trainer;

    }

    /**
     *
     * @param otherJsonObject
     */
    public void updateByJsonObject(JsonObject otherJsonObject) {
        this.allowedStepBack = otherJsonObject.getBoolean("allowed step back");
        this.freeMode = otherJsonObject.getBoolean("free mode");
        this.trainer = otherJsonObject.getBoolean("trainer");
    }

    @Override
    public boolean isThisObjectValid() {
        return true;
    }

    @Override
    public void setDefaultValues() {
        this.throwUnsupportedOperationExceptionIfThisObjectIsLocked();
        this.allowedStepBack = false;
        this.freeMode = false;
        this.trainer = false;

    }

    @Override
    public void setRandomValues() {
        this.throwUnsupportedOperationExceptionIfThisObjectIsLocked();
    }

    @Override
    public OtherComposition getCopy() {
        OtherComposition copy = new OtherComposition();
        copy.allowedStepBack = this.allowedStepBack;
        copy.freeMode = this.freeMode;
        copy.trainer = this.trainer;
        return copy;
    }

    /**
     *
     * @param allowedStepBack
     */
    public void setAllowedStepBack(boolean allowedStepBack) {
        this.throwUnsupportedOperationExceptionIfThisObjectIsLocked();
        this.allowedStepBack = allowedStepBack;
    }

    /**
     *
     * @return
     */
    public boolean getAllowedStepBack() {
        return this.allowedStepBack;
    }

    /**
     *
     * @param freeMode
     */
    public void setFreeMode(boolean freeMode) {
        this.throwUnsupportedOperationExceptionIfThisObjectIsLocked();
        this.freeMode = freeMode;
    }

    /**
     *
     * @return
     */
    public boolean getFreeMode() {
        return this.freeMode;
    }

    /**
     *
     * @param trainer
     */
    public void setTrainer(boolean trainer) {
        this.throwUnsupportedOperationExceptionIfThisObjectIsLocked();
        this.trainer = trainer;
    }

    /**
     *
     * @return
     */
    public boolean getTrainer() {
        return this.trainer;
    }

    @Override
    public List getListOfLockableObjects() {
        return new ArrayList<>();
    }

    /**
     *
     * @return
     */
    public JsonObject toJsonObject() {
        JsonObject otherCompositionJsonObject = new JsonObject();

        otherCompositionJsonObject.addBoolean("allowed step back", this.allowedStepBack);
        otherCompositionJsonObject.addBoolean("free mode", this.freeMode);
        otherCompositionJsonObject.addBoolean("trainer", this.trainer);
        return otherCompositionJsonObject;
    }
}
