package cls.logic.game;

import cls.ColorLinesSequelRuntimeException;

/**
 *
 * @author Robert Vokáč robertvokac1@gmail.comt Vokáč robertvokac1@gmail.com
 */
public enum Direction {

    /**
     *
     */
    TOP,
    /**
     *
     */
    TOPRIGHT,
    /**
     *
     */
    RIGHT,
    /**
     *
     */
    BOTTOMRIGHT,
    /**
     *
     */
    BOTTOM,
    /**
     *
     */
    BOTTOMLEFT,
    /**
     *
     */
    LEFT,
    /**
     *
     */
    TOPLEFT;
    private static final String ICANTOVERTURN = "I can't over turn.";

    /**
     *
     * @return
     */
    public Direction overTurn() {
        if (!isSlant()) {
            return overTurnStraightDirection(this);
        }
        if (isSlant()) {
            return overTurnSlantDirection(this);
        }
        throw new ColorLinesSequelRuntimeException(ICANTOVERTURN);

    }

    private static Direction overTurnStraightDirection(Direction direction) {
        switch (direction) {
            case TOP:
                return BOTTOM;
            case RIGHT:
                return LEFT;
            case BOTTOM:
                return TOP;
            case LEFT:
                return RIGHT;
            default:
                throw new ColorLinesSequelRuntimeException(ICANTOVERTURN);
        }
    }

    private static Direction overTurnSlantDirection(Direction direction) {
        switch (direction) {
            case TOPRIGHT:
                return BOTTOMLEFT;
            case BOTTOMRIGHT:
                return TOPLEFT;
            case BOTTOMLEFT:
                return TOPRIGHT;
            case TOPLEFT:
                return BOTTOMRIGHT;

            default:
                throw new ColorLinesSequelRuntimeException(ICANTOVERTURN);
        }
    }

    /**
     *
     * @return
     */
    public boolean isSlant() {
        return (this == TOPRIGHT) || (this == BOTTOMRIGHT) || (this == BOTTOMLEFT) || (this == TOPLEFT);

    }

}
