package cls.logic.game;

import okay.datetime.UniversalDateTime;

/**
 *
 * @author Robert Vokáč e-mail: robertvokac1@gmail.com
 */
public class GameAction {

    private final int row;
    private final int column;
    private final UniversalDateTime universalDateTime;

    /**
     *
     * @param row
     * @param column
     */
    public GameAction(int row, int column) {
        this.row = row;
        this.column = column;
        this.universalDateTime = UniversalDateTime.getCurrentUniversalDateTime();

    }

    /**
     *
     * @return
     */
    public int getRow() {
        return row;
    }

    /**
     *
     * @return
     */
    public int getColumn() {
        return column;
    }

    /**
     *
     * @return
     */
    public UniversalDateTime getUniversalDateTime() {
        return universalDateTime;
    }

    @Override
    public String toString() {
        return "*********************************\nField activated:: row: " + row + " column: " + column + " universalDateTime: " + universalDateTime.toString();
    }
}
