package cls.logic.game;

/**
 *
 * @author Robert Vokáč e-mail: robertvokac1@gmail.com
 * @param <T> the value of the node
 */
public class ParentNode<T> {

    private final ParentNode<T> parent;
    private final T value;

    /**
     *
     * @param parent
     * @param value
     */
    public ParentNode(ParentNode<T> parent, T value) {
        this.parent = parent;
        this.value = value;
    }

    /**
     *
     * @return
     */
    public ParentNode<T> getParent() {
        return parent;
    }

    /**
     *
     * @return
     */
    public T getValue() {
        return value;
    }

    /**
     *
     * @param value
     * @return
     */
    public ParentNode<T> createChild(T value) {
        return new ParentNode<>(this, value);
    }
}
