package cls.logic.game;

import cls.logic.game.board.Rollable;
import cls.ColorLinesSequel;
import java.util.List;

/**
 *
 * @author Robert Vokáč e-mail: robertvokac1@gmail.com
 */
public class TotalScore {

    private int score = 0;
    private boolean locked = false;
    private final int minimumCountOfBalls;

    /**
     * Constructor
     *
     * @param minimumCountOfBalls
     */
    public TotalScore(int minimumCountOfBalls) {
        this.minimumCountOfBalls = minimumCountOfBalls;
    }

    public int getCurrentTotalScore() {
        return this.score;
    }

    /**
     *
     * @param listOfExplodedRollable
     * @return sum of new added score
     */
    public int addListOfExplodedRollablesToCheck(List<Rollable> listOfExplodedRollable) {
        if (locked) {
            throw new cls.ColorLinesSequelRuntimeException("Total score is permanently locked for changes.");
        }
        if (listOfExplodedRollable == null) {
            return 0;
        }

        int scoreToAdd = ResultCounter.countScore(listOfExplodedRollable, minimumCountOfBalls);
        if (scoreToAdd != 0) {
            addNewScoreSum(scoreToAdd);
            ColorLinesSequel.getLogic().addChange("SCORE PLAYER " + this.getCurrentTotalScore());

        }
        return scoreToAdd;

    }

    private void addNewScoreSum(int value) {
        this.score = score + value;
    }

    /**
     * Locks score for changes. If this method is called and then the method
     * addListOfExplodedRollablesToCheck is called, new Exception is thrown.
     */
    public void lockForChanges() {
        this.locked = true;
    }
}
