package cls.logic.game.board;

import okay.json.JsonObject;

/**
 *
 * @author Robert Vokáč robertvokac1@gmail.comt Vokáč robertvokac1@gmail.com
 */
public class Bomb implements Rollable {

    private final boolean automatic;
    private boolean exploded = false;

    /**
     *
     * @param automatic
     */
    public Bomb(boolean automatic) {
        this.automatic = automatic;
        exploded = automatic;
    }

    /**
     *
     * @return
     */
    public boolean isAutomatic() {
        return this.automatic;
    }

    public boolean isManual() {
        return !this.automatic;
    }

    /**
     * Executes the explosion.
     */
    public void executeExplosion() {
        if (exploded) {
            throw new cls.ColorLinesSequelRuntimeException("Bomb has already exploded");
        }
        this.exploded = true;
    }

    /**
     *
     * @return
     */
    public boolean isExploded() {
        return exploded;
    }

    @Override
    public boolean isBall() {
        return false;
    }

    @Override
    public boolean isBomb() {
        return true;
    }

    /**
     * Converts bomb to json object
     *
     * @return
     */
    public JsonObject toJsonObject() {
        JsonObject jsonObject = new JsonObject();
        jsonObject.addBoolean("automatic", automatic);
        jsonObject.addBoolean("exploded", exploded);
        return jsonObject;
    }
}
