package cls.logic.game.board;

import cls.logic.game.Direction;

/**
 *
 * @author Robert Vokáč robertvokac1@gmail.comt Vokáč robertvokac1@gmail.com
 */
public class Walls {

    private boolean top = false;
    private boolean right = false;
    private boolean bottom = false;
    private boolean left = false;

    /**
     *
     * @param direction
     * @return
     */
    public boolean isWallAtDirection(Direction direction) {
        switch (direction) {
            case TOP:
                return top;
            case RIGHT:
                return right;
            case BOTTOM:
                return bottom;
            case LEFT:
                return left;
            default:
                throw new cls.ColorLinesSequelRuntimeException("Fatal error");
        }
    }

    /**
     *
     * @return
     */
    public boolean isTop() {
        return top;
    }

    /**
     *
     * @param top
     */
    public void setTop(boolean top) {
        this.top = top;
    }

    /**
     *
     * @return
     */
    public boolean isRight() {
        return right;
    }

    /**
     *
     * @param right
     */
    public void setRight(boolean right) {
        this.right = right;
    }

    /**
     *
     * @return
     */
    public boolean isBottom() {
        return bottom;
    }

    /**
     *
     * @param bottom
     */
    public void setBottom(boolean bottom) {
        this.bottom = bottom;
    }

    /**
     *
     * @return
     */
    public boolean isLeft() {
        return left;
    }

    /**
     *
     * @param left
     */
    public void setLeft(boolean left) {
        this.left = left;
    }

    /**
     * Destroys all walls.
     */
    public void destroyAll() {
        top = false;
        right = false;
        bottom = false;
        left = false;
    }

    /**
     *
     * @return
     */
    public boolean hasAWall() {
        return top || right || bottom || left;
    }

    @Override
    public String toString() {
        return top + " " + right + " " + bottom + " " + left;
    }
}
