package cls.services;

import cls.logic.GameManager;
import cls.logic.Logic;
import okay.json.JsonObject;

/**
 *
 * @author Robert Vokáč e-mail: robertvokac1@gmail.com
 */
public class GameCompositionService {

    private final Logic logic;
    private final GameManager gameManager;

    public GameCompositionService(Logic logic) {
        this.logic = logic;
        this.gameManager = logic.getGameManager();
    }

    public JsonObject getGameComposition() {
        return this.gameManager.getGameCompositionAsJsonObject();
    }

    public void setGameComposition(JsonObject gameComposition) {
        this.gameManager.setGameCompositionByJsonObject(gameComposition);
    }

    public void setGameCompositionRandom() {
        this.gameManager.setGameCompositionRandom();
    }

    public void setGameCompositionDefault() {
        this.gameManager.setGameCompositionDefault();
    }

    public void playNewGame() {
        this.gameManager.playNewGame();
    }
}
