package cls.services;

import cls.logic.Logic;
import cls.logic.TextSource;
import okay.database.ResultOfSqlQuery;

/**
 *
 * @author Robert Vokáč e-mail: robertvokac1@gmail.com
 */
public class LanguageService {

    private final Logic logic;
    private final TextSource textSource;

    public LanguageService(Logic logic) {
        this.logic = logic;
        this.textSource = logic.getTextSource();
    }

    /**
     *
     * @param type
     * @param languageID
     * @return
     */
    public String getTextConstant(int type) {
        return textSource.getTextConstant(type);
    }

    /**
     *
     * @return
     */
    public ResultOfSqlQuery getLanguages() {
        return textSource.getLanguages();
    }

    /**
     *
     * @param language
     * @return
     */
    public int convertLanguageNameToLanguageId(String language) {
        return textSource.convertLanguageNameToLanguageId(language);
    }

    /**
     *
     * @param languageID
     * @return
     */
    public String convertLanguageIdToLanguageName(int languageId) {
        return textSource.convertLanguageIdToLanguageName(languageId);
    }

}
