package cls.services;

import cls.logic.Logic;

/**
 *
 * @author Robert Vokáč e-mail: robertvokac1@gmail.com
 */
public class Services {

    private final Logic logic;

    private final ApplicationService applicationService;
    private final BeforeLoginService beforeLoginService;
    private final PlayerService playerService;
    private final AuthenticationService authenticationService;
    private final GameService gameService;
    private final GameCompositionService gameCompositionService;
    private final LanguageService languageService;
    private final PlayerSLookService lookService;
    private final CurrentLookService currentLookService;

    public Services(Logic logic) {
        this.logic = logic;
        applicationService = new ApplicationService(logic);
        beforeLoginService = new BeforeLoginService(logic);
        playerService = new PlayerService(logic);
        authenticationService = new AuthenticationService(logic);
        gameService = new GameService(logic);
        gameCompositionService = new GameCompositionService(logic);
        languageService = new LanguageService(logic);
        lookService = new PlayerSLookService(logic);
        this.currentLookService = new CurrentLookService(logic);
    }

    /**
     *
     * @return
     */
    public ApplicationService getApplicationService() {
        return applicationService;
    }

    /**
     *
     * @return
     */
    public BeforeLoginService getBeforeLoginService() {
        return beforeLoginService;
    }

    /**
     *
     * @return
     */
    public PlayerService getPlayerService() {
        return playerService;
    }

    /**
     *
     * @return
     */
    public AuthenticationService getAuthenticationService() {
        return authenticationService;
    }

    /**
     *
     * @return
     */
    public GameService getGameService() {
        return gameService;
    }

    /**
     *
     * @return
     */
    public GameCompositionService getGameCompositionService() {
        return gameCompositionService;
    }

    /**
     *
     * @return
     */
    public LanguageService getLanguageService() {
        return languageService;
    }

    /**
     *
     * @return
     */
    public PlayerSLookService getLookService() {
        return lookService;
    }

    public CurrentLookService getCurrentLookService() {
        return this.currentLookService;
    }

}
