package cls.view;

import cls.logic.NotifyableAboutChanges;
import static java.lang.Thread.sleep;
import java.util.Queue;
import java.util.concurrent.ConcurrentLinkedQueue;
import java.util.logging.Level;
import java.util.logging.Logger;

/**
 *
 * @author Robert Vokáč e-mail: robertvokac1@gmail.com
 */
public class ChangeExecutor extends Thread implements NotifyableAboutChanges {

    private final View view;
    private final Queue<String> queue;
    private boolean exit = false;

    public ChangeExecutor(View view) {
        this.queue = new ConcurrentLinkedQueue<>();

        this.view = view;
        this.setName("commandExecutor");
        this.start();
    }

    public synchronized void notifyAboutChange(String change) {
        if (change.equals("EXIT")) {
            exit = true;
        }
        if (change.equals("CLEAR")) {
            this.queue.clear();
            return;
        }
        this.queue.add(change);
    }

    @Override
    public void run() {
        while (!exit) {
            if (!queue.isEmpty()) {
                executeChanges();
            }
            try {
                sleep(25);
            } catch (InterruptedException ex) {
            }

        }
    }

    private synchronized void executeChanges() {
        Change change;
        while (!this.queue.isEmpty()) {
            String instructions = queue.poll();
            change = new Change(instructions, view);
            while (change.isAlive()) {
                try {
                    sleep(25);
                } catch (InterruptedException ex) {
                    Logger.getLogger(ChangeExecutor.class.getName()).log(Level.SEVERE, null, ex);
                }
            }
        }
    }

}
