package cls.view;

/**
 *
 * @author Robert Vokáč e-mail: robertvokac1@gmail.com
 */
public class ChangeReader {

    private final String[] splitCommand;
    private final int COUNTOFWORDS;

    public int getCountOfWords() {
        return COUNTOFWORDS;
    }
    private int currentIndex = -1;

    /**
     * Constructor
     *
     * @param command
     */
    public ChangeReader(String command) {
        splitCommand = command.split("\\s+");
        COUNTOFWORDS = splitCommand.length;
    }

    /**
     *
     * @return
     */
    public String getNextWord() {
        this.currentIndex++;
        return this.splitCommand[this.currentIndex];
    }

    public String getWord(int index) {
        if (index >= this.COUNTOFWORDS) {
            return "";
        }
        return this.splitCommand[index];
    }

    /**
     *
     * @return
     */
    public int getNextWordAsInt() {
        return Integer.parseInt(getNextWord());
    }

    /**
     *
     * @return
     */
    public boolean hasNextWord() {
        return (this.currentIndex) + 2 <= this.COUNTOFWORDS;
    }

    /**
     *
     * @return
     */
    public int getCurrentIndex() {
        return this.currentIndex;
    }

    /**
     *
     * @return
     */
    public String toStringAndMarkWordWithCurrentIndex() {
        StringBuilder stringBuilder = new StringBuilder();
        final String SPACE = " ";
        for (int i = 0; i < splitCommand.length; i++) {
            String element = splitCommand[i];
            if (i == this.currentIndex) {
                stringBuilder.append('[');
            }
            stringBuilder.append(element);
            if (i == this.currentIndex) {
                stringBuilder.append(']');
            }
            if (i != (splitCommand.length - 1)) {
                stringBuilder.append(SPACE);
            }
        }
        return stringBuilder.toString();
    }

}
