package cls.view;

import cls.ColorLinesSequel;
import okay.simplicity.EnumColour;
import cls.view.windows.SigningWindow;
import cls.logic.NotifyableAboutChanges;
import okay.simplicity.Simplicity;
import okay.simplicity.window.WindowColourSkin;
import cls.view.windows.GameWindow;
import okay.simplicity.Screen;

/**
 *
 * @author Robert Vokáč robertvokac1@gmail.comt Vokáč robertvokac1@gmail.com
 */
public class View implements NotifyableAboutChanges {

    private GameWindow gameWindow;
    private SigningWindow loginWindow = null;

    private final ChangeExecutor changeExecutor;

    /**
     *
     */
    public View() {
        changeExecutor = new ChangeExecutor(this);
    }

    /**
     *
     * @return
     */
    public double getDpmm() {
        return Screen.getDpmm();
    }

    public void start() {
        Simplicity.startSimplicity(new cls.view.RunObject(), new WindowColourSkin(EnumColour.GOLD));
    }

    /**
     *
     * @return
     */
    public String getTitleIconPath() {
        return "cls/view/images/logo.png";
    }

    /**
     *
     * @return
     */
    public WindowColourSkin getWindowColourSkin() {
        return new WindowColourSkin(ColorLinesSequel.getServices().getCurrentLookService().getColourSkin());
    }

    /**
     *
     * @return
     */
    public GameWindow getGameWindow() {
        return this.gameWindow;
    }

    void setGameWindow(GameWindow gameWindow) {
        this.gameWindow = gameWindow;
    }

    SigningWindow getLoginWindow() {
        return loginWindow;
    }

    void setLoginWindow(SigningWindow loginWindow) {
        this.loginWindow = loginWindow;
    }

    @Override
    public void notifyAboutChange(String change) {
        this.changeExecutor.notifyAboutChange(change);
    }

}
