package cls.view.windows;

import cls.ColorLinesSequel;
import okay.database.ResultOfSqlQuery;
import okay.simplicity.window.controls.SComboBox;

/**
 *
 * @author Robert Vokáč e-mail: robertvokac1@gmail.com
 */
public class LanguageComboBox extends SComboBox {

    /**
     *
     */
    public LanguageComboBox() {
        ResultOfSqlQuery languages = ColorLinesSequel.getServices().getLanguageService().getLanguages();
        while (languages.hasNextRow()) {
            languages.moveToTheNextRow();
            getItems().add(languages.getString("language_name_original"));
        }
        setDefault();
    }

    /**
     *
     * @return
     */
    public int getSelectedLanguageId() {
        return ColorLinesSequel.getServices().getLanguageService().convertLanguageNameToLanguageId(getValue().toString());
    }

    /**
     *
     */
    public void setDefault() {
        int currentLanguageId = ColorLinesSequel.getServices().getCurrentLookService().getLanguageId();
        setValue(ColorLinesSequel.getServices().getLanguageService().convertLanguageIdToLanguageName(currentLanguageId));
    }
}
