package cls.view.windows;

import cls.view.windows.playersettingswindow.*;
import javafx.stage.Modality;
import okay.simplicity.window.controls.TabPane;
import okay.simplicity.Simplicity;

/**
 *
 * @author Robert Vokáč robertvokac1@gmail.comt Vokáč robertvokac1@gmail.com
 */
public class PlayerSettingsWindow extends ColorLinesSequelAbstractWindow {

    private TabPane tabPane;

    private SigningTab signingTab;
    private LookTab lookTab;
    private OptionalDataTab optionalDataTab;
    private OtherTab otherTab;
    private BeforeSigningTab beforeSigningTab;

    /**
     * Constructor
     *
     */
    public PlayerSettingsWindow() {
        initModality(Modality.APPLICATION_MODAL);
        this.showOnlyTheCloseButton();
        this.setWidth(120 * Simplicity.getDpmm());
        this.setHeight(140 * Simplicity.getDpmm() + 50);
        this.centerOnScreen();
    }

    /**
     *
     */
    @Override
    public void initAreaForUserInteraction() {
        String title = cls.ColorLinesSequel.getServices().getLanguageService().getTextConstant(1115);
        this.setWindowTitle(title);

        signingTab = new SigningTab();
        lookTab = new LookTab();
        optionalDataTab = new OptionalDataTab();
        otherTab = new OtherTab();
        beforeSigningTab = new BeforeSigningTab();

        tabPane = new TabPane();
        tabPane.getTabs().addAll(signingTab, lookTab, optionalDataTab, otherTab, beforeSigningTab);

        this.applicationArea.getChildren().add(tabPane);
    }

    /**
     *
     */
    @Override
    public void onClosingWindow() {

    }
}
