package cls.view.windows;

import cls.ColorLinesSequel;
import javafx.event.ActionEvent;
import javafx.geometry.Pos;
import okay.simplicity.boxes.AlertBox;
import okay.simplicity.window.controls.Button;
import okay.simplicity.window.controls.SCheckBox;
import okay.simplicity.window.controls.SLabel;
import okay.simplicity.window.controls.PasswordField;
import okay.simplicity.window.controls.TextField;
import okay.simplicity.window.CellLayout;

/**
 *
 * @author Robert Vokáč robertvokac1@gmail.comt Vokáč robertvokac1@gmail.com
 */
public class SigningWindow extends ColorLinesSequelAbstractWindow {

    private CellLayout cellLayout;

    private SLabel nickSLabel;
    private TextField nickSTextField;
    private SLabel passwordSLabel;
    private PasswordField passwordSPasswordField;

    private SCheckBox keepMeSignedInSCheckBox;

    private Button signInButton;
    private Button viewHelpButton;
    private Button createNewPlayerButton;

    /**
     *
     */
    public SigningWindow() {
    }

    /**
     *
     */
    @Override
    public void onResizingWindow() {
    }

    /**
     *
     */
    @Override
    public void onClosingWindow() {
        ColorLinesSequel.getServices().getApplicationService().exit();
    }

    /**
     *
     */
    @Override
    public void initAreaForUserInteraction() {
        cellLayout = new CellLayout(2, 8, "50% 50%");

        this.showOnlyTheCloseButton();
        this.applicationArea.getChildren().addAll(this.cellLayout);

        nickSLabel = new SLabel(cls.ColorLinesSequel.getServices().getLanguageService().getTextConstant(111) + ":");
        nickSTextField = new TextField();

        passwordSLabel = new SLabel(cls.ColorLinesSequel.getServices().getLanguageService().getTextConstant(112) + ":");
        passwordSPasswordField = new PasswordField();

        this.keepMeSignedInSCheckBox = new SCheckBox();
        this.keepMeSignedInSCheckBox.setCheckBoxText(cls.ColorLinesSequel.getServices().getLanguageService().getTextConstant(121));

        signInButton = new Button(cls.ColorLinesSequel.getServices().getLanguageService().getTextConstant(131));
        viewHelpButton = new Button(cls.ColorLinesSequel.getServices().getLanguageService().getTextConstant(132));
        createNewPlayerButton = new Button(cls.ColorLinesSequel.getServices().getLanguageService().getTextConstant(133));
        this.signInButton.setOnAction(this::handleSignInButtonAction);
        this.viewHelpButton.setOnAction(this::handleViewHelpButtonAction);
        this.createNewPlayerButton.setOnAction(this::handleCreateNewPlayerButtonAction);

        this.setWindowTitle(cls.ColorLinesSequel.getServices().getLanguageService().getTextConstant(101));
        this.applicationArea.setAlignment(Pos.BOTTOM_CENTER);
        this.cellLayout.addNodes(1, this.nickSLabel, nickSTextField);
        this.cellLayout.addNodes(2, this.passwordSLabel, this.passwordSPasswordField);
        this.cellLayout.addNodes(3, this.keepMeSignedInSCheckBox, this.signInButton);
        this.cellLayout.addNodes(4, this.viewHelpButton, this.createNewPlayerButton);
        this.setWidth(90 * ColorLinesSequel.getView().getDpmm());
        this.setHeight(45 * ColorLinesSequel.getView().getDpmm());
    }

    private void handleSignInButtonAction(ActionEvent event) {
        String nick = this.nickSTextField.getText();
        String password = this.passwordSPasswordField.getText();
        if (ColorLinesSequel.getServices().getAuthenticationService().logIn(nick, password, this.keepMeSignedInSCheckBox.isSelected())) {

        } else {
            AlertBox.showBox(cls.ColorLinesSequel.getServices().getLanguageService().getTextConstant(2), cls.ColorLinesSequel.getServices().getLanguageService().getTextConstant(151));
        }
    }

    private void handleViewHelpButtonAction(ActionEvent event) {
        HelpWindow helpWindow = new HelpWindow();
        helpWindow.show();
    }

    private void handleCreateNewPlayerButtonAction(ActionEvent event) {
        CreatingNewPlayerWindow window = new CreatingNewPlayerWindow();
        window.show();
    }
}
