package cls.view.windows.customcompositionwindow;

import javafx.scene.control.Tab;
import okay.json.JsonObject;
import okay.simplicity.window.CellLayout;
import okay.simplicity.window.controls.SCheckBox;

/**
 *
 * @author Robert Vokáč e-mail: robertvokac1@gmail.com
 */
public class OtherTab extends Tab {

    private SCheckBox allowStepBackCheckBox;
    private SCheckBox freeModeCheckBox;
    private SCheckBox trainerCheckBox;

    private final CellLayout cellLayout;

    /**
     *
     */
    public OtherTab() {
        super(cls.ColorLinesSequel.getServices().getLanguageService().getTextConstant(20500));
        this.setClosable(false);
        cellLayout = initCellLayout();

        initNodes();

        fillCellLayout();
    }

    private void fillCellLayout() {
        cellLayout.addNodes(1, allowStepBackCheckBox);
        cellLayout.addNodes(2, freeModeCheckBox);
        cellLayout.addNodes(3, trainerCheckBox);

        setContent(cellLayout);
    }

    private CellLayout initCellLayout() {
        CellLayout cellLayout = new CellLayout(1, 3, "100%");
        return cellLayout;
    }

    private void initNodes() {
        initCheckBoxes();
    }

    private void initCheckBoxes() {
        allowStepBackCheckBox = new SCheckBox(cls.ColorLinesSequel.getServices().getLanguageService().getTextConstant(20501));
        freeModeCheckBox = new SCheckBox(cls.ColorLinesSequel.getServices().getLanguageService().getTextConstant(20502));
        trainerCheckBox = new SCheckBox(cls.ColorLinesSequel.getServices().getLanguageService().getTextConstant(20503));
    }

    /**
     *
     * @param jsonObject
     */
    public void updateByJsonObject(JsonObject jsonObject) {
        this.allowStepBackCheckBox.setSelected(jsonObject.getBoolean("allowed step back"));
        this.freeModeCheckBox.setSelected(jsonObject.getBoolean("free mode"));
        this.trainerCheckBox.setSelected(jsonObject.getBoolean("trainer"));
    }

    /**
     *
     * @return
     */
    public JsonObject toJsonObject() {
        JsonObject otherCompositionJsonObject = new JsonObject();

        otherCompositionJsonObject.addBoolean("allowed step back", this.allowStepBackCheckBox.isSelected());
        otherCompositionJsonObject.addBoolean("free mode", this.freeModeCheckBox.isSelected());
        otherCompositionJsonObject.addBoolean("trainer", this.trainerCheckBox.isSelected());

        return otherCompositionJsonObject;
    }
}
