package cls.view.windows.gamingwindow;

import javafx.scene.layout.ColumnConstraints;
import javafx.scene.layout.GridPane;
import javafx.scene.layout.RowConstraints;

/**
 *
 * @author Robert Vokáč e-mail: robertvokac1@gmail.com
 */
public class Grid extends GridPane {

    private final ColumnConstraints barColumnConstraints;
    private final ColumnConstraints spaceColumnConstraints;
    private final RowConstraints barRowConstraints;
    private final RowConstraints spaceRowConstraints;

    /**
     *
     */
    public Grid() {
        barColumnConstraints = new ColumnConstraints();
        spaceColumnConstraints = new ColumnConstraints();
        barRowConstraints = new RowConstraints();
        spaceRowConstraints = new RowConstraints();

        barColumnConstraints.setPercentWidth(5);
        spaceColumnConstraints.setPercentWidth(30);
        barRowConstraints.setPercentHeight(5);
        spaceRowConstraints.setPercentHeight(30);

        this.getColumnConstraints().addAll(spaceColumnConstraints, barColumnConstraints, spaceColumnConstraints, barColumnConstraints, spaceColumnConstraints);
        this.getRowConstraints().addAll(spaceRowConstraints, barRowConstraints, spaceRowConstraints, barRowConstraints, spaceRowConstraints);

        this.addRow(0, new GridSpace(), new GridBar(), new GridSpace(), new GridBar(), new GridSpace());
        this.add(new GridBar(), 0, 1, 5, 1);
        this.addRow(2, new GridSpace(), new GridBar(), new GridSpace(), new GridBar(), new GridSpace());
        this.add(new GridBar(), 0, 3, 5, 1);
        this.addRow(4, new GridSpace(), new GridBar(), new GridSpace(), new GridBar(), new GridSpace());
    }
}
