package cls.view.windows.playersettingswindow;

import cls.ColorLinesSequel;
import cls.view.windows.TimeZoneComboBox;
import javafx.event.Event;
import javafx.scene.control.Tab;
import okay.simplicity.window.CellLayout;
import okay.simplicity.window.controls.Button;
import okay.simplicity.window.controls.SLabel;

/**
 *
 * @author Robert Vokáč e-mail: robertvokac1@gmail.com
 */
public class OtherTab extends Tab {

    private SLabel timeZoneLabel;
    private TimeZoneComboBox timeZoneComboBox;

    private Button saveOtherChangesButton;

    private CellLayout cellLayout;

    /**
     *
     */
    public OtherTab() {
        super(cls.ColorLinesSequel.getServices().getLanguageService().getTextConstant(10801));
        this.setClosable(false);
        cellLayout = initCellLayout();

        initNodes();

        fillCellLayout();
    }

    private void fillCellLayout() {
        cellLayout.addNodes(1, this.timeZoneLabel, this.timeZoneComboBox);
        cellLayout.addNode(this.saveOtherChangesButton, 2, 5);

        setContent(cellLayout);
    }

    private CellLayout initCellLayout() {
        CellLayout cellLayout = new CellLayout(2, 5, "50% 50%");
        return cellLayout;
    }

    private void initNodes() {
        initLabels();
        initComboBoxes();
        initButtons();
    }

    private void initLabels() {
        timeZoneLabel = new SLabel(cls.ColorLinesSequel.getServices().getLanguageService().getTextConstant(10811));
    }

    private void initComboBoxes() {
        this.timeZoneComboBox = new TimeZoneComboBox();
        timeZoneComboBox.setValue(ColorLinesSequel.getServices().getPlayerService().getTimeZoneName());

    }

    private void initButtons() {
        this.saveOtherChangesButton = new Button(cls.ColorLinesSequel.getServices().getLanguageService().getTextConstant(10891));
        this.saveOtherChangesButton.setOnAction(this::handleSaveOtherChangesButtonAction);
    }

    private void handleSaveOtherChangesButtonAction(Event e) {
        String timeZoneName = this.timeZoneComboBox.getValue().toString();
        ColorLinesSequel.getServices().getPlayerService().setTimeZoneName(timeZoneName);
    }

}
